<%@ page
    import="com.websina.bean.*,com.websina.util.*"
%>
<html>
<head>
<title>Project field edit</title>
<script type="text/javascript" src="script/item_mover.js"></script>
</head>
<body topmargin=0>
<%@ include file="_header.jspf" %>
<%      
  String msg = com.websina.servlet.SessionUtil.getMessage(session, request);
  String mainTitle = label.get("admin_field_edit");
  String subTitle = ""; 
  Project conf = null;
  Field drivingFields = null;
  if (projectId != null && projectId.trim().length()>0) {
    conf = Project.getInstance(projectId);
    mainTitle += ": ";
    subTitle = admin.getProjectDisplay(projectId);
    if (!conf.isPersisted()) {
      msg = MessageCode.get("servlet.project.not_persisted", lang);
      conf = null;
      projectId = null;
    }
  } else {
    projectId = null;
  }
%>
<%-- the title part --%>
<form style="margin-top:10px;">
<table cellpadding=0 cellspacing=0 width="100%" border=0>
  <tr><td align=right><font color="#000000"><b><%=label.get("project_label")%></b></font>&nbsp;
     <select name="project" 
        style="font-size:14px;"
        onChange="location.href='fieldedit.jsp?projectId='+form.project.options[form.project.selectedIndex].value;">
        <%=ListMaker.makeOptionList(admin.getProjects(), currentProject) %>
        </select>
      <input type="button" class="button" value=" <%=label.get("edit_button")%> " 
      onClick="location.href='fieldedit.jsp?projectId='+form.project.options[form.project.selectedIndex].value;" <%=(admin.getProjects().isEmpty())?"disabled":""%>>
  </td></tr>
  <tr class="f1"><td align=center height=30><font size=+1><b><%=mainTitle%></b></font>
  &nbsp;<font color="#cccc00"><b><%=subTitle%></b></font>
  </td></tr>
</table>
</form>
<center>
<p>
<%=com.websina.servlet.ServletUtil.formatMessage(msg)%>
<% if (conf == null) {
   if (msg == null) { // for instruction only %>
<table>
<tr><td height=380 valign=top>
<%=label.get("admin_common_intro")%>
</td></tr>
</table>
<% }} else if ((drivingFields = admin.getDrivingFields(conf)) == null) { %>
<table><tr><td height=100><%=label.get("admin_field_edit_not_applicable")%></td></tr></table>
<% } else { 
  FieldEdit fieldEdit = conf.getFieldEdit();
  String[] fieldOptionList = null;
  String[] fieldOptionText = null;
  String fn = request.getParameter("fn");
  if (fn != null && conf.isValidField(fn)) {
    com.websina.util.Field field = conf.getField(fn);
    if (field.isTextField()) {
      fieldOptionList = new String[]{"0", "1"};
      fieldOptionText = new String[]{"When blank", "When Filled"};
    } else {
      fieldOptionList = field.getValue();
      fieldOptionText = fieldOptionList;
    }
  } else {
    fn = null;
  }
%>
<form name="fieldedit" method="post" action="<%=contextPath%>/servlet/project" onsubmit="return false;">
<input type="hidden" name="token" value='<%=com.websina.servlet.SessionUtil.getToken(session)%>'>
<input type="hidden" name="projectId" value="<%=projectId%>">
<input type="hidden" name="action" value="fieldedit">
<table cellpadding=0 cellspacing=0 border=0 width=95%>
<tr><td>
<%=label.get("admin_field_text")%>
</td></tr><tr><td>&nbsp;</td></tr>
<tr><td><table cellpadding=2 cellspacing=2 border=0>
<%String[] fs = drivingFields.getValue();
  int count = 0;
  for (int i=0; i<fs.length; i++) {
    String name = fs[i];
    if (fieldEdit.isDriveFieldForDisabled(name) || fieldEdit.isDriveFieldForMandatory(name)) {if (fn == null) fn=name; %>
<tr><td><%=(count++==0)?label.get("admin_field_saved_field"):"&nbsp;"%></td><td width=16>&nbsp;</td><td align=right>
<%=label.get(name, projectId)%> (<%=name%>)
<input class="button" type="button" value="<%=label.get("delete_button")%>"
onClick="if (confirm('<%=label.getEscaped("delete_confirmation")%>')){
action.value='fieldedit_delete'; fn.value='<%=name%>'; submit();}"></td></tr>
<%}}%></table></td></tr>
<tr><td align=middle height=60>
<select name="fn"
  onChange="location.href='fieldedit.jsp?projectId=<%=projectId%>&fn='+fieldedit.fn.options[fieldedit.fn.selectedIndex].value;">
  <%=ListMaker.makeOptionList(drivingFields, fn)%>
</select>
<input class="button" type="button" value="<%=label.get("go_button")%>" 
  onClick="location.href='fieldedit.jsp?projectId=<%=projectId%>&fn='+fieldedit.fn.options[fieldedit.fn.selectedIndex].value;">
</td></tr>
</table> 

<%if (fieldOptionList != null) { %>
<table cellpadding=2 cellspacing=0 border=0 class="box">
<%java.util.List availableList = fieldEdit.getAvailableFields(fn);
  String fname = label.get(fn, projectId);
  for (int index=0; index<fieldOptionList.length; index++) {
    String option = fieldOptionList[index];
    java.util.List dis = fieldEdit.getDisabled(fn, option);
    java.util.List hid = fieldEdit.getHidden(fn, option);
    java.util.List man = fieldEdit.getMandatory(fn, option);
    String[] optionList = (dis != null)? (String[])dis.toArray(new String[0]):null;
    String[] optionList1 = (hid != null)? (String[])hid.toArray(new String[0]):null;
    String[] optionList2 = (man != null)? (String[])man.toArray(new String[0]):null;
    java.util.List tempList = new java.util.ArrayList();
    if (availableList != null) tempList.addAll(availableList);
    if (dis != null) tempList.removeAll(dis);
    if (hid != null) tempList.removeAll(hid);
    if (man != null) tempList.removeAll(man);
    String[] srcList = (String[])tempList.toArray(new String[0]);
%>
<tr><td class="f1" colspan=3 align=center height=30 valign=bottom>
<%=HtmlParser.escapeTag(fname + ": " + fieldOptionText[index])%>
</td></tr>
<tr><td rowspan=3 class="e8" align=center>
&nbsp;<%=label.get("admin_field_available")%><br>
<select multiple size="15" name="src_<%=index%>">
   <%=ListMaker.makeOptionList(label, projectId, srcList, null) %>
</select></td>
<td class="e8" align=center width=100>
<input type="button" class="button" value="  >>  " onclick="move(form.src_<%=index%>,form.dis_<%=index%>)"><br>
<input type="button" class="button" value="  <<  " onclick="move(form.dis_<%=index%>,form.src_<%=index%>)">
</td>
<td class="e8" align=center>
&nbsp;<%=label.get("admin_field_disabled")%><br>
<select multiple size="4" name="dis_<%=index%>">
   <%=ListMaker.makeOptionList(label, projectId, optionList, null) %>
</select></td></tr>
<tr><td class="e8" align=center width=100>
<input type="button" class="button" value="  >>  " onclick="move(form.src_<%=index%>,form.hid_<%=index%>)"><br>
<input type="button" class="button" value="  <<  " onclick="move(form.hid_<%=index%>,form.src_<%=index%>)">
</td>
<td class="e8" align=center>
&nbsp;<%=label.get("admin_field_hidden")%><br>
<select multiple size="4" name="hid_<%=index%>">
   <%=ListMaker.makeOptionList(label, projectId, optionList1, null) %>
</select></td></tr>
<tr><td class="e8" align=center width=100>
<input type="button" class="button" value="  >>  " onclick="move(form.src_<%=index%>,form.man_<%=index%>)"><br>
<input type="button" class="button" value="  <<  " onclick="move(form.man_<%=index%>,form.src_<%=index%>)">
</td>
<td class="e8" align=center>
&nbsp;<%=label.get("admin_field_mandatory")%><br>
<select multiple size="4" name="man_<%=index%>">
   <%=ListMaker.makeOptionList(label, projectId, optionList2, null) %>
</select></td></tr>
<% } %>

<%-- finally the save/reset buttons --%>
<tr><td class="f1" colspan=3 align=center height=36 valign=bottom>
<input type="button" class="button" value="<%=label.get("save_button")%>" onClick=" 
<%
  for (int index=0; index<fieldOptionList.length; index++) {
%>
  selectAll(form.dis_<%=index%>);
  selectAll(form.hid_<%=index%>);
  selectAll(form.man_<%=index%>);
<% }%>
this.disabled=true; submit();">
<input type="button" class="button" value="<%=label.get("reset_button")%>"
onClick="location.href='fieldedit.jsp?projectId=<%=projectId%>&fn=<%=fn%>'">
</td></tr>
</table>
<% } %>
</form>
<% } %>
<%-- end of editing project/permission --%>
</center>
<%com.websina.servlet.JspUtil.include(application, request, response, out, "/jsp/customizable/footer.html");%>
</body>
</html>